module Talk

data Bool = False | True

-----------------------------------------------------------------
{-

    Idris allows you to say whether arguments are relevant or not.
    So we can make the `a` in `id` relevant, and then match on it.

-}

id : a -> a
-- id True = False
id x = x






































----------------------------------------------------------------------------
{- Idris allows relevant, dependent quantification easily, and allows multiplicity
   to determine whether an argument should be erased. -}

data Nat = Zero | Succ Nat

data Vec : Nat -> Type -> Type where
  Nil  : Vec Zero a
  (:>) : a -> Vec n a -> Vec (Succ n) a
infixr 5 :>

vReplicate : {n : Nat} -> a -> Vec n a
vReplicate {n = Zero}   _ = Nil
vReplicate {n = Succ n} x = x :> vReplicate x
